import React from 'react';
declare const defaultOptions: {
    r: number;
    scaleRByWheel: boolean;
    minR: number;
    maxR: number;
    /**
     * @description 放大镜样式
     */
    delegateStyle: {
        stroke: string;
        strokeOpacity: number;
        lineWidth: number;
        fillOpacity: number;
        fill: string;
    };
    showLabel: boolean;
};
export interface FishEyeProps {
    /**
     * @description 是否开启
     * @default false
     */
    visible: boolean;
    /**
     * @description FishEye的配置项
     * @default { r: 249,scaleRByWheel: true,minR: 100,maxR: 500 }
     */
    options?: Partial<typeof defaultOptions>;
    /**
     * @description 监听用户按下 ESC 键的回调函数
     * @default ()=>{}
     */
    handleEscListener?: () => void;
}
declare const FishEye: React.FunctionComponent<FishEyeProps>;
export default FishEye;
