/* eslint-disable no-undef */
import React from 'react';
import { G6, GraphinContext } from '../../index'; // import type  {SnapLineConfig} from '@antv/g6-plugin/es/snapline/'

var defaultOptions = {
  line: {
    stroke: '#FA8C16',
    lineWidth: 0.5
  },
  itemAlignType: 'center'
};

var SnapLine = function SnapLine(props) {
  var _React$useContext = React.useContext(GraphinContext),
      graph = _React$useContext.graph;

  var options = props.options,
      visible = props.visible;
  React.useEffect(function () {
    var Options = Object.assign(Object.assign({}, defaultOptions), options); // eslint-disable-next-line @typescript-eslint/no-explicit-any

    var snapLine = new G6.SnapLine(Options);

    if (visible) {
      graph.addPlugin(snapLine);
    }

    return function () {
      if (graph && !graph.destroyed) {
        graph.removePlugin(snapLine);
      }
    };
  }, [graph, options, visible]);
  return null;
};

export default SnapLine;