import { ModelConfig } from '@antv/g6';
import React from 'react';
import './index.less';
import { State } from './useTooltip';
export interface TooltipValue {
    bindType: 'node' | 'edge';
    item: State['item'];
    id: string;
    model: ModelConfig;
}
export interface TooltipProps {
    /**
     * @description tooltip绑定的图元素
     * @default node
     */
    bindType?: 'node' | 'edge';
    /**
     * @description children
     * @type  React.ReactChild | JSX.Element
     */
    children: (props: TooltipValue) => React.ReactNode;
    /**
     * @description styles
     */
    style?: React.CSSProperties;
    /**
     * @description Tooltip 的位置
     */
    placement?: 'top' | 'bottom' | 'right' | 'left' | 'center';
    /**
     * @description 是否展示小箭头
     * @description.en-US display arrow
     */
    hasArrow?: boolean;
}
declare const Tooltip: React.FunctionComponent<TooltipProps>;
export default Tooltip;
