import React from 'react';
import { IG6GraphEvent } from '../../index';
export interface ContextMenuProps {
    bindType?: 'node' | 'edge' | 'canvas';
    container: React.RefObject<HTMLDivElement>;
}
export interface State {
    /** 当前状态 */
    visible: boolean;
    x: number;
    y: number;
    /** 触发的元素 */
    item: IG6GraphEvent['item'];
    /** 只有绑定canvas的时候才触发 */
    selectedItems: IG6GraphEvent['item'][];
}
declare const useContextMenu: (props: ContextMenuProps) => {
    oneShow: (e: IG6GraphEvent) => void;
    onClose: () => void;
    item: import("@antv/g6-core").Item | null;
    selectedItems: (import("@antv/g6-core").Item | null)[];
    visible: boolean;
    x: number;
    y: number;
};
export default useContextMenu;
