"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _index = require("../../index");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint-disable no-undef */
// import type  {SnapLineConfig} from '@antv/g6-plugin/es/snapline/'
var defaultOptions = {
  line: {
    stroke: '#FA8C16',
    lineWidth: 0.5
  },
  itemAlignType: 'center'
};

var SnapLine = function SnapLine(props) {
  var _React$useContext = _react.default.useContext(_index.GraphinContext),
      graph = _React$useContext.graph;

  var options = props.options,
      visible = props.visible;

  _react.default.useEffect(function () {
    var Options = Object.assign(Object.assign({}, defaultOptions), options); // eslint-disable-next-line @typescript-eslint/no-explicit-any

    var snapLine = new _index.G6.SnapLine(Options);

    if (visible) {
      graph.addPlugin(snapLine);
    }

    return function () {
      if (graph && !graph.destroyed) {
        graph.removePlugin(snapLine);
      }
    };
  }, [graph, options, visible]);

  return null;
};

var _default = SnapLine;
exports.default = _default;