import Behaviors from './behaviors';
import Components from './components';
import Graphin from './Graphin';
import GraphinContext from './GraphinContext';
import Utils from './utils';
export { default as G6 } from '@antv/g6';
/** export type */
export type { 
/** export G6 Type  */
EdgeConfig, Graph, GraphData, IG6GraphEvent, NodeConfig, TreeGraphData, } from '@antv/g6';
/** Components Typing */
export type { ContextMenuValue } from './components/ContextMenu/index';
export type { HullCfg } from './components/Hull/index';
export type { LegendChildrenProps } from './components/Legend/typing';
export type { TooltipValue } from './components/Tooltip/index';
export type { GraphinContextType } from './GraphinContext';
export type { ThemeType } from './theme';
export type { EdgeStyle, GraphinData, GraphinTreeData, IUserEdge, IUserNode, Layout, NodeStyle } from './typings/type';
export { Utils, GraphinContext, Behaviors, Components, registerFontFamily };
export interface GraphEvent extends MouseEvent {
    item: any;
    target: any;
}
/** 解构静态方法 */
declare const registerFontFamily: typeof Graphin.registerFontFamily;
/** export */
export default Graphin;
